--local printOutlined = require("printOutlined_simplified")
local printOutlined = require("printOutlined")


-- UTILS TIME TEST --

local timeTest = function(f, ...)
    local t1, r, t2 = os.clock(), f(...), os.clock()
    return t2 - t1, r
end

local average = function(tbl)
    local sum = 0
    for _, v in ipairs(tbl) do
        sum = sum + v
    end
    return sum / #tbl
end


-- MAIN --

function love.load()
    love.window.setMode(800,600,{vsync=0})
    Font = love.graphics.newFont(64)
    love.graphics.setFont(Font)
end

local times = {}
function love.update(dt)
    if #times == 10000 then
        love.event.quit(0)
    end
end

function love.draw()

    times[#times+1] = timeTest(printOutlined, "Hello World !", 200, 200, 2, 1,1,1,1, 0,0,0,1)
 -- times[#times+1] = timeTest(printOutlined, "Hello World !", 200, 200, 2, {1,1,1,1}, {0,0,0,1})

    love.graphics.setColor(1,1,1)
    love.graphics.print(("%d%%"):format((#times/10000)*100))

end

function love.quit()
    print(("%.6f secondes"):format(average(times)))
end
